#include "LN.h"
#include <math.h>
using namespace std;

// sets the values in LN only at the beginning
void LymphNode::initializeValues()
{
  allFirstThousandTCells = 1000; // decremented to determine first thousand Tcells
  // parameters to control the update intervals for each kind of cell
  step_tcell = 20; // 5 in other file
  step_dcell = 80; // 20 in other file // 8 min * 60 sec/min * 1 timestep/6 sec
  
  
  // filename[100];  // just  a string to store filenames
  synch = 0;  // Type of update : 0 synchronous, 1,2 asynchronous
  
  
  NEW_H_CELLS = 0;
  NEW_K_CELLS = 0;
  
  for (int row = 0; row < 960; row++){
    histo[row] = 0;
  }
  for (int row = 0; row < 1000; row++){
    searchTime[row]= 0;
  }
  for(int row = 0; row < 1000; row++){
    pathLengths[row] = 0;
    lifetimeDisplacement[row] = 0;
  }
  for(int row = 0; row < hMDCContactsTotal.size(); row++){   // reset all vector elements to 0
    
    for (int col = 0; col <= 3; col++) {
      hMDCContactsTotal[row][col]=0;
    }
    hMDCContactsNaive[row]=0;
    hMDCContactsNaiveCognate[row]=0;
    hMDCContactsUnique[row]=0;
    hMDCContactsActiveUnique[row]=0;
    hMDCContactsCognate[row]=0;
    hMDCContactsNonCognate[row]=0;
    hMDCBoundTotal[row] = 0;
    hMDCActivatedTotal[row] = 0;
    
    for (int col = 0; col <= 3; col++) {
          hLDCContactsTotal[row][col]=0;
    }
    hLDCContactsNaive[row]=0;
    hLDCContactsNaiveCognate[row]=0;
    hLDCContactsUnique[row]=0;
    hLDCContactsActiveUnique[row]=0;
    hLDCContactsCognate[row]=0;
    hLDCContactsNonCognate[row]=0;
    hLDCBoundTotal[row] = 0;
    hLDCActivatedTotal[row] = 0;
    
    for (int col = 0; col <= 3; col++) {
      kMDCContactsTotal[row][col]=0;
    }
    kMDCContactsNaive[row]=0;
    kMDCContactsNaiveCognate[row]=0;
    kMDCContactsUnique[row]=0;
    kMDCContactsActiveUnique[row]=0;
    kMDCContactsCognate[row]=0;
    kMDCContactsNonCognate[row]=0;
    kMDCBoundTotal[row] = 0;
    kMDCActivatedTotal[row] = 0;
   
  
    for (int col = 0; col <= 3; col++) {
        kLDCContactsTotal[row][col]=0;
    }
    kLDCContactsNaive[row]=0;
    kLDCContactsNaiveCognate[row]=0;
    kLDCContactsUnique[row]=0;
    kLDCContactsActiveUnique[row]=0;
    kLDCContactsCognate[row]=0;
    kLDCContactsNonCognate[row]=0;
    kLDCBoundTotal[row] = 0;
    kLDCActivatedTotal[row] = 0;
  } 
  for (int i = 0; i < hCognate.size(); i++)
	hCognate[i].clear();    
  hCognate.clear();
  for (int i = 0; i < kCognate.size(); i++)
	kCognate[i].clear();
  kCognate.clear();

  n_hcells = 0; // number of hcells created
  n_kcells = 0; // number of kcells created
  n_cog_hcells = 0;
  n_cog_kcells = 0;

  n_t4_cells_leave = 0; // # naive t4 cells leave
  
  n_t4a_cells_leave = 0; // # active t4 cells leave
  
  
  n_t4e_cells_leave = 0; // # effector t4 cells leave
  
  
  n_t8_cells_leave = 0; // # naive t8 cell leave
  
  n_t8a_cells_leave = 0; // # active t8 cells leave
  
  
  n_t8e_cells_leave = 0; // # effector t8 cells leave
  
  
  n_t8m_cells_leave = 0; // # memory t8 cells leave
  
  
  time_t timer;
  tm* timest;
  
  time(&timer);
  timest = localtime(&timer); 
  
  sprintf(filename,"data/frames/LN-%02d%02d%02d-%02d%02d-",timest->tm_mon+1,
	  timest->tm_mday,timest->tm_year,timest->tm_hour,timest->tm_min);
  readIniFile("LN.ini");
  
  index_t4 = 2; // 0; // 2 in other file // index for helper cell id's
  index_t8 = 1; // 30000; // 1 in other file // index for killer cell id's
  index_dc = 0; // 60000; // 0 in other file //  index for dendritic cell id's
  
  brickWallCounter = 0; // number of times cells hit obstacles

  // reinitializeValues();
}

// resets certain values in LN each row/run.
void LymphNode::reinitializeValues()
{
}
int LymphNode::recruitDCs(int t, double a, double b, double c, double d)
{
	return (a*t*t*t) - (b*t*t) + c*t - d ;
}

// MAIN PART OF THE PROGRAM THAT CALLS ALL THE OTHER FUNCTIONS
int LymphNode::run() 
{
  //cout << "Calling initializeValues() " << endl;
  initializeValues();
  counter = 0;
  double DC_recruitment = 0;
  int nMDC_created = 0;
  int nMDC_killed = 0;
  int nDC_total = 0;
  for(int row = 0; row < MROWS; row++) {
    for(int col = 0; col < MCOLS; col++) {
      for(int i = 0; i < microcompartment::NUM_CELLS; i++){
	M[row][col].cell[i] = NULL;
      }
    }
  }

  time_t initime = time(NULL);

  /*vector<int> immature_agenda;
  //cout << "p.INITIAL_iDENDRITIC_CELLS  is " <<  p.INITIAL_iDENDRITIC_CELLS() << endl;
  immature_agenda.reserve(p.INITIAL_DENDRITIC_CELLS() + p.NDAYS());

  for(int i = 0; i < p.INITIAL_DENDRITIC_CELLS(); i++){
    immature_agenda.push_back(idc_afferent[2 * i] * MCOLS + idc_afferent[2 * i + 1]);
    // int pos = i / (2 * p.INITIAL_iDENDRITIC_CELLS());
    // immature_agenda.push_back(afferent[2 * pos] * MCOLS + afferent[2 * pos + 1]);
  }
  // create initial IDCs 
  if(immature_agenda.size() > 0){
	  for(int i = immature_agenda.size() - 1; i >= 0; i--) {
		  if(M[immature_agenda[i] / MCOLS][immature_agenda[i] % MCOLS].is_empty()){
			  create_dcell(immature_agenda[i] / MCOLS, immature_agenda[i] % MCOLS, counter, D_IMMATURE,  0);
			  immature_agenda.erase((vector<int>::iterator)&immature_agenda[i]);
		  } // end if
	  } // end for
  } // end if
  */
  vector<int> agenda; // holds dendritic cell's positions while they wait to be created
  agenda.reserve((p.INITIAL_DENDRITIC_CELLS() + p.PEAK_DEN_CELLS()) * 4);
  cout << "COGNATE_KCELL is " << p.COGNATE_KCELL << endl;
  cout << "COGNATE_HCELL is " << p.COGNATE_HCELL << endl;
  //cout << "a = " << p.A()/10000 << ", b = " << p.B()/100 << ", c = " << p.C()/10 << ", d = " << p.D()/100 << endl;
  cout << "PROB_eHELPER_LICENSES_MDC: " << p.PROB_eHELPER_LICENSES_MDC() << endl;
  set_helpercells_random();
  //cout << "Calling set_killercells_random() " << endl;
  set_killercells_random();
  
  //cout << "Number of ALs: " << NAFFERENT << ", AL locations are: " << endl;
  //for (int j = 0; j < NAFFERENT; j++ )
	//cout << "[" << afferent[j*2] << "][" << afferent[j*2+1] << "]" << endl;
  cout << "counter " << counter << endl; // should print counter 0
  save_frame();

  // declaring time steps -- this saves some time at run-time
  const int oneHour = 600;
  const int twoHours = 2 * 600;
  const int threeHours = 3 * 600;
  const int sixHours = 6 * 600;
  const int nineHours = 9 * 600;
  const int twelveHours = 12 * 600;
  const int fifteenHours = 15 * 600;
  const int sixteenHours = 16 * 600;
  const int seventeenHours = 17 * 600;
  const int eighteenHours = 18 * 600;
  const int twentyoneHours = 21 * 600;
  const int twentyFourHours = 24 * 600;
  const int thirtyHours = 30 * 600;
  const int thirtySixHours = 36 * 600;
  const int fortyTwoHours = 42 * 600;
  const int fortyEightHours = 48 * 600;
  const int fiftyFourHours = 54 * 600;
  const int sixtyHours = 60 * 600;
  const int sixtySixHours = 66 * 600;
  const int seventyTwoHours = 72 * 600;
  const int seventyEightHours = 78 * 600;
  const int eightyFourHours = 84 * 600;
  const int ninetyHours = 90 * 600;
  const int ninetySixHours = 96 * 600;
  const int oneHundredEightHours = 108 * 600;
  const int oneHundredTwentyHours = 120 * 600;
  const int oneHundredThirtyTwoHours = 132 * 600;
  const int oneHundredFortyFourHours = 144 * 600;
  const int oneHundredFiftySixHours = 156 * 600;
  const int oneHundredSixtyFiveHours = 165 * 600;
  
  //const int fourdays = 4 * 24 * 600;
  //const int fivedays = 5 * 24 * 600;
  //const int sixdays = 6 * 24 * 600;
  const int sevenDays = 7 * 24 * 600;
  //const int eightdays = 7 * 24 * 600;
  //const int ninedays = 9 * 24 * 600;
  //const int tendays = 10 * 24 * 600;
  //const int elevendays = 11 * 24 * 600;  
  //const int twelvedays = 12 * 24 * 600;
  //const int thirteendays = 13 * 24 * 600;
  //const int fourteendays = 14 * 24 * 600; 

  // int whichAfferent = 0;
  
  for(counter = 1; counter <= (p.NDAYS() * 24 * 600) + fifteenHours; counter++) {
    
    if (counter == fifteenHours) // create initial_DCs at 15 hours
    {
  		for(int j = 0; j < p.INITIAL_DENDRITIC_CELLS() / NAFFERENT; j++) {
    			for(int i = 0; i < NAFFERENT; i++) {
      				agenda.push_back(afferent[2 * i] * MCOLS + afferent[2 * i + 1]);
    			}
  		}
  		for(int i = 0; i < p.INITIAL_DENDRITIC_CELLS() % NAFFERENT; i++) {
    			agenda.push_back(afferent[2 * i] * MCOLS + afferent[2 * i + 1]);
  		}
  
  		// create initial DCs 
    		if(agenda.size() > 0){
  	  		for(int i = agenda.size() - 1; i >= 0; i--) {
  		  		if(M[agenda[i] / MCOLS][agenda[i] % MCOLS].is_empty()){
  			  		create_dcell(agenda[i] / MCOLS, agenda[i] % MCOLS, counter, 0);
  			  		agenda.erase((vector<int>::iterator)&agenda[i]);
  		  		} // end if
  	  		} // end for
    		} // end if
		cout << "\nCounter: " << counter / 600 << " hr" << endl;
		cout << "LD size: " << LD.size() << endl;
		cout << "NID: " << NID << endl;
    		cout << "NMD: " << NMD << endl;
    		cout << "NLD: " << NLD << endl;
		cout << "agenda.size(): " << agenda.size() << endl;
		DC_recruitmentFile << counter / 600 << "\t" << p.INITIAL_DENDRITIC_CELLS() << "\t" << NMD << "\t" << NLD  << "\t" << NMD+NLD << "\t" 
			<< NID+NMD+NLD << endl;

  	 }
    if(CHRONIC)
    {
	
        if(counter >= sixteenHours && counter % oneHour == 0)
        {
	    if(counter == sixteenHours){
    		cout << "\nCounter: " << counter / 600 << " hr" << endl;
		cout << "LD size: " << LD.size() << endl;
		cout << "NID: " << NID << endl;
    		cout << "NMD: " << NMD << endl;
    		cout << "NLD: " << NLD << endl;
		int numMDenCells = NID + NMD + NLD + agenda.size();
    		int numNewMDenCells = (p.PEAK_DEN_CELLS() * .10 - numMDenCells);
    		//cerr << "numNewMDenCells: " << numNewMDenCells << endl;
    		for(int i = numNewMDenCells; i > 0; i--){
    			int whichAfferent = rnd.Next(0, NAFFERENT - 1);
    			// whichAfferent = (whichAfferent + 1) % NAFFERENT;
    			agenda.push_back(afferent[2 * whichAfferent] * MCOLS + afferent[2 * whichAfferent + 1]);
    		}
    	        cout << "agenda.size(): " << agenda.size() << endl;
	        DC_recruitmentFile << counter / 600 << "\t" << p.PEAK_DEN_CELLS() * .10 << "\t" << NMD << "\t" << NLD << "\t" << NMD+NLD << "\t" << NID+NMD+NLD << endl;
    	    }
            else if(counter == seventeenHours){
    		cout << "\nCounter: " << counter / 600 << " hr" << endl;
		cout << "LD size: " << LD.size() << endl;
		cout << "NID: " << NID << endl;
    		cout << "NMD: " << NMD << endl;
    		cout << "NLD: " << NLD << endl;
    		int numMDenCells = NID + NMD + NLD + agenda.size();
    		int numNewMDenCells = (p.PEAK_DEN_CELLS() * .12 - numMDenCells );
    		//cerr << "numNewMDenCells: " << numNewMDenCells << endl;
    		for(int i = numNewMDenCells; i > 0; i--){
    			int whichAfferent = rnd.Next(0, NAFFERENT - 1);
    			// whichAfferent = (whichAfferent + 1) % NAFFERENT;
    			agenda.push_back(afferent[2 * whichAfferent] * MCOLS + afferent[2 * whichAfferent + 1]);
    		}
    	        cout << "agenda.size(): " << agenda.size() << endl;
	        DC_recruitmentFile << counter / 600 << "\t" << p.PEAK_DEN_CELLS() * .12 << "\t" << NMD << "\t" << NLD << "\t" << NMD+NLD << "\t" << NID+NMD+NLD << endl;
    	        }
	     else if( counter <= ninetySixHours + fifteenHours)
             {
    		cout << "\nCounter: " << counter / 600 << " hr" << endl;
		cout << "LD size: " << LD.size() << endl;
		cout << "NID: " << NID << endl;
    		cout << "NMD: " << NMD << endl;
    		cout << "NLD: " << NLD << endl;
    		int numMDenCells = NID + NMD + NLD + agenda.size();
		DC_recruitment = recruitDCs ((counter - fifteenHours) / 600, p.A()/10000, p.B()/100, p.C()/10, p.D()/100);
		cout << "DC_recruitment: " << DC_recruitment << endl;
    		int numNewMDenCells = (p.PEAK_DEN_CELLS() * (DC_recruitment/100) - numMDenCells);
    		//cout << "numNewMDenCells: " << numNewMDenCells << endl;
    		for(int i = numNewMDenCells; i > 0; i--){
    			int whichAfferent = rnd.Next(0, NAFFERENT - 1);
    			// whichAfferent = (whichAfferent + 1) % NAFFERENT;
    			agenda.push_back(afferent[2 * whichAfferent] * MCOLS + afferent[2 * whichAfferent + 1]);
    		}
    	        cout << "agenda.size(): " << agenda.size() << endl;
	        DC_recruitmentFile << counter / 600 << "\t" << DC_recruitment << "\t" << NMD << "\t" << NLD << "\t" << NMD+NLD << "\t" << NID+NMD+NLD << endl;
    	     }
    	 } // end if (counter % == 0 )    
    }
    
    if (agenda.size() > 0 ) 
    {
	    if ( (counter % threeHours) == 0 )
	    {
			//cout << "Creating DCs from agenda ..." ;
			//cout << "agenda.size before: " << agenda.size() << endl;
	    }
	    int k = 0;
	    int n = agenda.size();
           for ( int i = n - 1; i >= 0; i--) // for each element of agenda
           { 
        	bool found_site = false;   // whether or not found a site to create a new MDC
        	if(M[agenda[i] / MCOLS][agenda[i] % MCOLS].is_empty()){
        		found_site = true;
	     	       nDC_total = create_dcell(agenda[i] / MCOLS, agenda[i] % MCOLS, counter,  /*cognate*/ 0);
		       //cout << "nDC_total: " << nDC_total << endl;
	     	       nMDC_created++;
		       //cout << "nMDC_created: " << nMDC_created << endl;
	     	       agenda.erase((vector<int>::iterator)&agenda[i]);
        	} // end if
		while ( !found_site && k <= NAFFERENT*10)
	       {
		    k++;
	           int AL = rnd.Next(0, NAFFERENT - 1); // choose AL randomly
		    if (M[afferent[2 * AL]][afferent[2 * AL + 1]].is_empty())  // check if this AL is free
		    {
		  	found_site = true;
		       nDC_total=create_dcell(afferent[2 * AL],afferent[2 * AL + 1], counter, /*cognate*/ 0);
		        //cout << "nDC_total: " << nDC_total << endl;
			nMDC_created++;
			//cout << "nMDC_created: " << nMDC_created << endl;
		    	agenda.erase((vector<int>::iterator)&agenda[i]);
		    } // end if empty
	       } // end while
		 			 
		if ( found_site == false ) // no free ALs available at this time
		{
		   //cout << "No free AL locations at this time " << endl;
	           break;  // break out of for i
		}            
           } // end for i
	    //if ( (counter % threeHours) == 0)
		//cout << "agenda.size after: " << agenda.size() << endl;
   } // end if agenda.size() > 0
    
   if((counter % step_tcell) == 0) {
      recruit_h_cells();
      move_helpercell();
      recruit_k_cells();
      move_killercell();
   }
    
   if((counter % step_dcell) == 0) {
      recruit_d_cells();
      move_dendriticcell();
   }
    
   if ((counter % step_tcell) == 0) {
      update(0, nDC_total);
      remove_dead_cells();
      save_frame();
   }
    
   if (PROG){
      if (counter % 10000 == 0){
	// cerr << counter << endl; 
    	  cout << counter << endl;
      }  
   }
 } // for counter

  for(int i = 0; i < MROWS; i++){
    for(int j = 0; j < MCOLS; j++){
      if(!M[i][j].is_empty() 
	 && M[i][j].cell[0]->is_tcell()
	 && ((Tcell*)M[i][j].cell[0])->inFirstThousandTCells){
	lifetimeDisplacement[(int)((Tcell*)M[i][j].cell[0])->calcDist(i, j)]++;
	if(M[i][j].is_full()
	   && ((Tcell*)M[i][j].cell[1])->inFirstThousandTCells){
	  lifetimeDisplacement[(int)((Tcell*)M[i][j].cell[1])->calcDist(i,j)]++;
	}
      }
    }
  }

  time_t fintime = time(NULL);
  int ntime = (int)difftime(fintime, initime); 
  int nhour = ntime / 3600;
  ntime = ntime % 3600;
  int nmin = ntime / 60;
  ntime = ntime % 60;
  int nsec = ntime;
  
  printf("Time : %dh %dm %ds\n", nhour, nmin, nsec); 
  
  // agenda.clear();
  freeLNMemory();

  return 0;
}

void LymphNode::update(int synch, int nDC)
{
  int len = 0; // used to store length, cuts down on runtime
  int i = 0; // used to store iteration, creating it once slightly cuts runtime

  if (synch==2) {  // asynchronous sequential update
    for (i = 0; i < LH.size(); i++)
      LH.elem(i)->cell_pointer->state = next_state_helperTcell(LH.elem(i), nDC);
    for (i = 0; i < LK.size(); i++)
      LK.elem(i)->cell_pointer->state = next_state_killerTcell(LK.elem(i));
    for (i = 0; i < LD.size(); i++)
      LD.elem(i)->cell_pointer->state = next_state_dcell(LD.elem(i));
  }else if (synch==1) { //asynchronous random order update
    int* ind = NULL; // used as a temporary variable for swapping
    int ri = -1; // stores a random index, creating it once slightly cuts runtime
    try
    {
    	ind = new int[LH.size()];
    }
    catch (bad_alloc error)
    {
    	cout << error.what() << endl;
    	cout<< "Memory could not be allocated to new ind in update() " << endl;
    	cout << "Exiting...." << endl;
    	exit(1);
    }
    for (i = 0; i < LH.size(); i++) ind[i] = i;
    for (i = 0; i < LH.size(); i++) {
      ri = rnd.Next(0, LH.size());
      swap(ind[i], ind[ri]);
    } 
    for (i = 0; i < LH.size(); i++)
      LH.elem(ind[i])->cell_pointer->state = next_state_helperTcell(LH.elem(ind[i]), nDC);
    delete[] ind;
    try
    {
    	ind = new int[LK.size()];
    }
    catch (bad_alloc error)
    {
        cout << error.what() << endl;
        cout<< "Memory could not be allocated to new ind in update() " << endl;
        cout << "Exiting...." << endl;
        exit(1);
    }
    for (i=0;i<LK.size();i++) ind[i]=i;
    for (i=0;i<LK.size(); i++) {
      ri=rnd.Next(0,LK.size());
      swap(ind[i], ind[ri]);
    } 
    for (i = 0; i < LK.size(); i++)
      LK.elem(ind[i])->cell_pointer->state = next_state_killerTcell(LK.elem(ind[i]));
    delete[] ind;
    try
    {
    	ind = new int[LD.size()];
    }
    catch (bad_alloc error)
    {
       cout << error.what() << endl;
       cout<< "Memory could not be allocated to new ind in update() " << endl;
       cout << "Exiting...." << endl;
       exit(1);
    }
    for (i=0;i<LD.size();i++) ind[i]=i;
    for (i=0;i<LD.size(); i++) {
      ri=rnd.Next(0,LD.size());
      swap(ind[i], ind[ri]);
    } 
    for (i = 0; i < LD.size(); i++)
      LD.elem(ind[i])->cell_pointer->state = next_state_dcell(LD.elem(ind[i]));
    delete[] ind;
    
  }else if (synch==0) {  // synchronous update
    len=LH.size();
    for (i=0;i<len;i++){
      LH.elem(i)->cell_pointer->next_state = next_state_helperTcell(LH.elem(i), nDC);
    }
    len=LK.size();
    for (i=0;i<len;i++){
      LK.elem(i)->cell_pointer->next_state = next_state_killerTcell(LK.elem(i));
    }
    len=LD.size();
    for (i=0;i<len;i++){
      LD.elem(i)->cell_pointer->next_state = next_state_dcell(LD.elem(i));
    }
    len=LH.size();
    for (i=0;i<len;i++){
      LH.elem(i)->cell_pointer->state = LH.elem(i)->cell_pointer->next_state;
    }
    len=LK.size();
    for (i=0;i<len;i++){
      LK.elem(i)->cell_pointer->state = LK.elem(i)->cell_pointer->next_state;
    }
    len=LD.size();
    for (i=0;i<len;i++){
      LD.elem(i)->cell_pointer->state = LD.elem(i)->cell_pointer->next_state;
    }
    // update n_pMHC to account for the decay
    len=LD.size();
    for (i=0;i<len;i++){
    	d_cell* dptr = (d_cell*) LD.elem(i)->cell_pointer;
    	dptr->n_pMHC = dptr->n_pMHC * pMHC_decay;
    }
    int d = 0;
    bool idMatch = false;
    if ( counter % 600 == 0) // print pMHC of 50 DCs at every hour
    {
	pMHCfile << counter << "\t";
	for ( d = 0; d < 50; d++ )
        {
	    idMatch = false;
    	    pMHCfile << (d*6+1) * 3 << "\t";
	    for (i=0;i<len;i++){
		d_cell* dptr = (d_cell*) LD.elem(i)->cell_pointer;
	    	if (dptr->id == ((d*6+1)*3))
		{
		   idMatch = true;
		   pMHCfile <<  dptr->n_pMHC << "\t";
		}
	    }
	    if (!idMatch)
		pMHCfile << "" << "\t";
	}
	pMHCfile << endl;
    }
    // update hcell binding history
    len=LH.size();
    for (i=0;i<len;i++){
    	h_cell* hptr = (h_cell*) LH.elem(i)->cell_pointer;
    	if (hptr->state == H_RESTING) // decay  binding history of unbound cells
    	{
    		hptr->contact_history = hptr->contact_history * (p.DECAY_TCELL_CONTACT_HISTORY() / 1000000);
    		hptr->binding_history = hptr->binding_history * (p.DECAY_TCELL_BINDING_HISTORY() / 1000000);
    	}
    }
    // update kcell binding history
    len=LK.size();
    for (i=0;i<len;i++){
        k_cell* kptr = (k_cell*) LK.elem(i)->cell_pointer;
        if (kptr->state == K_RESTING)
        {
        	kptr->contact_history = kptr->contact_history * (p.DECAY_TCELL_CONTACT_HISTORY() / 1000000);
        	kptr->binding_history = kptr->binding_history * (p.DECAY_TCELL_BINDING_HISTORY() / 1000000);
        }
    }
  }
}

void LymphNode::freeLNMemory()
{
  delete[] idc_afferent;
  delete[] efferent; // array that contains efferent coordinates
  delete[] afferent; // array that contains afferent coordinates
  delete[] sources; // array that contains T sources coordinates
  for(int i = LH.size() - 1; i >= 0; i--){
    ((Tcell*)(LH.elem(i))->cell_pointer)->dcContacted.clear();
    ((Tcell*)(LH.elem(i))->cell_pointer)->dcContactedActive.clear();
    LH.erase(LH.elem(i));
  }
  for(int i = LK.size() - 1; i >= 0; i--){
    ((Tcell*)(LK.elem(i))->cell_pointer)->dcContacted.clear();
    ((Tcell*)(LK.elem(i))->cell_pointer)->dcContactedActive.clear();
    LK.erase(LK.elem(i));
  }
  cout << "Size of LD is " << LD.size() << endl;
  for(int i = LD.size() - 1; i >= 0; i--){
    LD.erase(LD.elem(i));
  }
	  
  // LH.clear();
  // LK.clear();
  // LD.clear();
}

int main(int argc, char** argv) 
{
  system("mkdir data");
  if(system("cd data; ls; pwd")){
    cerr << "Could not create data folder.  Exiting." << endl;
    exit(1);
  }

  //system("mkdir data/frames");
  //if(system("cd data/frames; ls; pwd")){
  //  cerr << "Could not create frames subfolder.  Exiting." << endl;
  //  exit(2);
  //}
  char str[50], s[50];
  ifstream lhsmatrix;
  int i, j;
  float x, y;
  
  ofstream file;
  LymphNode LN;
  //int DC_space = 8 * (LN.p.INITIAL_DENDRITIC_CELLS()  +  LN.p.PEAK_DEN_CELLS());
  cout << "DC_space: " << LN.DC_space << endl;
  bool random = true;
  time_t begtime = time(NULL);

  if (argc == 1) {
    // LN.readParFile("LN.par"); This is done in LN's ctor
    sprintf(&LN.filename[20],".sta");
    LN.statfile.open(LN.filename);
    LN.run();
    LN.statfile.close();

    ofstream file;
    file.open("./data/transitTimes.txt");
    file << "// row number is how long it takes the cell to leave in tenths of hours" << endl;  
    for (int b=0;b<960;b++) {
      cout << LN.histo[b]<<endl; 
      file << LN.histo[b]<<endl; 
    }    		
    file.close();
  }else if (argc >= 2) {
    if (argv[1][0]!='-' || strlen(argv[1])<2) {
      cerr << "Invalid arg values.  Exiting." << endl;
      exit(0);
    }
    if(argv[1][1] == 't'){
    	LN.pMHC_decay = exp(log(0.5) / (30 * LN.p.pMHC_HALFLIFE())); // if updated every 20 time steps
    	cout << "pMHC halflife: " << LN.p.pMHC_HALFLIFE() << ", pMHC decay: " << LN.pMHC_decay << endl;
      
      if(argc > 7 && 's' == argv[5][1]){
	// This allows the user to set the seed at run-time.
	int seedAlpha = atoi(argv[6]);
	int seedBeta = atoi(argv[7]);
	LN.rnd.Reset(seedAlpha, seedBeta);
	random = false;
	cout << "The random seed is set to: " << seedAlpha << " and " << seedBeta << "." << endl;
      }

      // LN.readParFile("LN.par"); this is done in lN's ctor
      LN.SAVE_FRAME = false;
      LN.PROG = true;
      const int row = 0; // 0 is the row in the LHS matrix, but we don't have a matrix here.
      int numRuns = 2;
      if(argc > 3 && 'r' == argv[2][1]){
	numRuns = atoi(argv[3]);
	if(numRuns > 80){
	  // 80 is an arbitrarily chosen big number
	  cout << "You have chosen to have more than 80 runs.  There is no reason to do more than 80 runs. " << endl;
	  cout << "There will be 80 runs.  If you would like to do more than 80 runs, let Laura know." << endl;
	  numRuns = 80;
	}
      }else{
	cout << "You have not listed the number of runs you would like. " << endl;
	cout << "If you would like to specify the number of runs, please " << endl; 
	cout << "type \" ./LN -t -runs # \" without the quotes, where # is the " << endl;
	cout << "number of runs that you would like. " << endl;
      }

      if(argc > 4 && 'c' == argv[4][1]){
	LN.CHRONIC = true;
      }


      if(LN.PROG){
	cout << "I will print the timestep counter as I progress." << endl; 
      }else{
	cout << "I am not going to print the timestep counter as I progress.  If you would like" << endl
	     << " me to, please change the PROG value in LNmain." << endl;
      }

      if(LN.CHRONIC){
	cout << "You have chosen to release dendritic cells throughout the run." << endl;
      }else{
	cout << "You have chosen to not release dendritic dendritic cells throughout the run." << endl
	     << "If you would like chronic dendritic cells, please use this form: " << endl
	     << " ./LN -t -runs # -chronic " << endl;
      }

      cout << "I should be printing this data to the data subfolder." << endl;
      if(LN.SAVE_FRAME){
	cout << "I am saving frames. I should be printing these frames to the frames subfolder of data." << endl << endl;
      }else{
	cout << "I am not saving frames. " << endl;
      }

      if(random){
	cout << "The random seed has not been set.  The output of this run will be truly random. " << endl;
      }else{
	cout << "The random seed has been set.  Please do this only when de-bugging." << endl;
      }
      cout << "There will be " << numRuns << " runs. " << endl;
      cout << endl;
      sprintf(str, "./data/Tcells_created.txt");
      LN.Tcells_createdFile.open(str);
      LN.Tcells_createdFile << "Total CD4 Tcells" << "\t" << "Cognate CD4 cells" << "\t" 
		<< "Total CD8 Tcells" << "\t" << "Cognate CD8 cells" << endl;
      
	for (int run = 0; run < numRuns; run++) {
    	  sprintf(str,"./data/pMHC-%02d.txt", run);
    	  LN.pMHCfile.open(str);
    	  LN.pMHCfile  << "Counter" << "\t";
    	  for ( i = 0; i < 50; i++)
    	  {
    		  LN.pMHCfile << "DC_id" << "\t" <<  "n_pMHC" << "\t";
    	  }
    	  LN.pMHCfile << endl;
    	  
    	  sprintf(str,"./data/hCogContacts-%02d.txt", run);
    	  LN.hCogContactsFile.open(str);
    	  LN.hCogContactsFile << "// When a cognate hcell finds a DC " << endl;
    	  LN.hCogContactsFile << "counter" << "\t" << "hId" << "\t" << "hLoc" << "\t" << "n_DcContacts" << "\t" << "n_UniqueDcContacts" 
    	                  << "\t" << "DcId" << "\t" << "DcLoc" << "\t" << "DC_state" << "\t" << "ntcellsBound" << "\t" << "prob_binding"
    	                  << "\t" << "bound" << "\t" << "binding_history" <<  endl;
    	  
    	  sprintf(str,"./data/kCogContacts-%02d.txt", run);
    	  LN.kCogContactsFile.open(str);
    	  LN.kCogContactsFile << "// When a cognate kcell finds a DC " << endl;
    	  LN.kCogContactsFile << "counter" << "\t" << "kId" << "\t" << "kLoc" << "\t" << "n_DcContacts" << "\t" << "n_UniqueDcContacts" 
    	      	                  << "\t" << "DcId" << "\t" << "DcLoc" << "\t" << "DC_state" << "\t" << "ntcellsBound" << "\t" << "prob_binding"
    	    	                  << "\t" << "bound"<< "\t" << "binding_history"<< endl;
    	  
    	  sprintf(str,"./data/lhspulse-%02d.sta", run);
    	  LN.statfile.open(str);
    	  LN.statfile<<"NRH"<<"\t"<<"NAH"<<"\t"<<"NEH"<<"\t"<<"NRK"<<"\t"<<"NAK"
		   <<"\t"<<"NEK"<<"\t"<<"NMK"<<"\t"<<"NID"<< "\t"<<"NMD"<<"\t"<<"NLD"<<"\t"
		   <<"t4_o" << "\t"
		   <<"t4a_o"<<"\t"
		   <<"t4e_o"<<"\t" 
		   <<"t8_o"<< "\t"
		   <<"t8a_o"<<"\t" 
		   <<"t8e_o"<<"\t" 
		   <<"t8m_o"<< "\t" << endl;
	  
	  sprintf(str,"./data/DC_recruitment-%02d.txt", run);
    	  LN.DC_recruitmentFile.open(str);
	  LN.DC_recruitmentFile << "Hour" << "\t" << "DC_recruitment" << "\t" << "MDC" << "\t" << "LDC" << "\t" << "MDC+LDC" << "\t" << "Total_DC" << endl;
    	  printf("************ Run number: %d *******************\n", run + 1);
	// if you want to use a loop to do multiple runs
    	  // **************************************
    	  LN.run();
    	  // **************************************
    	  LN.pMHCfile.close();
    	  LN.hCogContactsFile.close();
    	  LN.kCogContactsFile.close();
    	  LN.statfile.close();
	  LN.DC_recruitmentFile.close();

	  sprintf(str, "./data/hCognate-%02d.txt", run);
	  file.open(str);          
	  file << "Cog_h_id" << "\t" << "binding_prob" << "\t" << "bound" << "\t" << "activation_prob" << "\t" 
		<< "activated" << "\t" << "activation_time" << "\t" << "searchTime" << "\t" << "transitTime" << endl;
      for ( int i = 0; i < LN.hCognate.size(); i++)
	  {
              //if ( LN.hCognate[i][0] > ((LN.p.INITIAL_rHELPERT_CELLS()*3) - 1) ) // recruited hcells only
	          file << LN.hCognate[i][0] << "\t" << LN.hCognate[i][1] << "\t"
	               << LN.hCognate[i][2] << "\t" << LN.hCognate[i][3] << "\t"  
	               << LN.hCognate[i][4] << "\t" << LN.hCognate[i][5] << "\t"
			 << LN.hCognate[i][6] << "\t" << LN.hCognate[i][7] << endl;
	  }
	  file.close();
	  
	  sprintf(str, "./data/kCognate-%02d.txt", run);
	  file.open(str);          
	  file << "Cog_k_id" << "\t" << "binding_prob" << "\t" << "bound" << "\t" << "activation_prob" << "\t" 
		<< "activated" << "\t" << "activation_time" << "\t" << "searchTime" << "\t" << "transitTime" << endl;
	  for ( int i = 0; i < LN.kCognate.size(); i++)
	  {
	           //if ( LN.kCognate[i][0] > ((LN.p.INITIAL_rKILLERT_CELLS()*3) - 2) ) // recruited hcells only
	  	          file << LN.kCognate[i][0] << "\t" << LN.kCognate[i][1] << "\t"
	  	          	 << LN.kCognate[i][2] << "\t" << LN.kCognate[i][3] << "\t"
	  	               << LN.kCognate[i][4] << "\t" << LN.kCognate[i][5] << "\t"
				 << LN.kCognate[i][6] << "\t" << LN.kCognate[i][7] << endl;
	  }
	  file.close();
          
	 
	sprintf(str, "./data/lifetimeDisplacement-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// row numberis how far a cell is from its entrance when it dies, exits, or the simulation ends. "
	     << "This distance is measured in microcompartments." << endl;
	for(int k = 0; k < LN.lifetimeDisplacement.size(); k++){
	  file << LN.lifetimeDisplacement[k] << endl;
	}
	file.close();
	sprintf(str,"./data/transitTimes-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// row number is how long it takes the cell to leave in tenths of hours" << endl;
	for (int b = 0; b < 960; b++) file << LN.histo[b] << endl;
	file.close();
	
	sprintf(str,"./data/MDCContactsWithHcells-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// Col 1 == DC id, col 2 == initial pMHC on DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), col 4 == total hcell contacts(active/non-active, naive/non-naive), "
		 <<	"col 5 == total Naive hcell contacts, col 6 == total unique naive hcell contacts, "
		 << "col 7 == number active hcells contacting a unique dcell, col 8 == total contacts with cognate hcells, "
		 <<	"col 9 == total contacts with naive non-cognate hcells, col 10 == total contacts with naive cognate hcells, " 
		 << "col 11== total number of hcells bound, col 12 == total number of hcells activated" << endl;  
	for (j = 0; j < LN.hMDCContactsTotal.size(); j++) {
	
		file << LN.hMDCContactsTotal[j][0] << " "; // col 1
	    file << LN.hMDCContactsTotal[j][1] << " "; // col 2
	    file << LN.hMDCContactsTotal[j][2] << " "; // col 3
	    file << LN.hMDCContactsTotal[j][3] << " "; // col 4
	    file << LN.hMDCContactsNaive[j] << " ";//col 5
	    file << LN.hMDCContactsUnique[j] << " ";//col 6
	    file << LN.hMDCContactsActiveUnique[j] << " ";//col 7
	    file << LN.hMDCContactsCognate[j] << " ";//col 8
	    file << LN.hMDCContactsNonCognate[j] << " "; //col 9    
	    file << LN.hMDCContactsNaiveCognate[j] << " "; // col 10 
	    file << LN.hMDCBoundTotal[j] << " "; // col 11
	    file << LN.hMDCActivatedTotal[j] << endl; // col 12
	} 
	file.close();

	sprintf(str,"./data/LDCContactsWithHcells-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// Col 1 == DC id, col 2 == initial pMHC on DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), col 4 == total hcell contacts(active/non-active, naive/non-naive), "
             <<  "col 5 == total Naive hcell contacts, col 6 == total unique naive hcell contacts, "
	     << "col 7 == number active hcells contacting a unique dcell, col 8 == total contacts with cognate hcells, "
	     << "col 9 == total contacts with naive non-cognate hcells, col 10 == total contacts with naive cognate hcell" 
	     << "col 11== total number of hcells bound, col 12 == total number of hcells activated" << endl;
	for (j = 0; j < LN.hLDCContactsTotal.size(); j++) {
		file << LN.hLDCContactsTotal[j][0] << " "; // col 1  
  		file << LN.hLDCContactsTotal[j][1] << " "; // col 2   
   		file << LN.hLDCContactsTotal[j][2] << " "; // col 3     
     	file << LN.hLDCContactsTotal[j][3] << " "; // col 4     
     	file << LN.hLDCContactsNaive[j] << " ";//col 5           
	   	file << LN.hLDCContactsUnique[j] << " ";//col 6        
		file << LN.hLDCContactsActiveUnique[j] << " ";//col 7        
		file << LN.hLDCContactsCognate[j] << " ";//col 8         
	 	file << LN.hLDCContactsNonCognate[j] << " "; //col 9       
       	file << LN.hLDCContactsNaiveCognate[j] << " "; // col 10       
       	file << LN.hLDCBoundTotal[j] << " "; // col 11       
       	file << LN.hLDCActivatedTotal[j] << endl; // col 12
	}
	file.close();

	sprintf(str,"./data/MDCContactsWithKcells-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// Col 1 == DC id, col 2 == initial_pMHC of DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), col 4 == total kcell contacts(active/non-active, naive/non-naive), "
		 <<	"col 5== total Naive kcell contacts, col 6 == total unique naive kcell contacts, "
		 <<	 "col 7 == number active kcells contacting a unique dcell, col 8 == total contacts with cognate kcells, "
         << "col 9 == total contacts with naive non-cognate kcells, col 10 == total contacts with naive cognate kcells, "
         << "col 11 == total kcells bound to DC, col 12 == total kcells activated by DC"<< endl;
        		 
	for (j = 0; j < LN.kMDCContactsTotal.size(); j++) {
	   	file << LN.kMDCContactsTotal[j][0] << " "; // col 1
	   	file << LN.kMDCContactsTotal[j][1] << " "; // col 2
	   	file << LN.kMDCContactsTotal[j][2] << " "; // col 3
	   	file << LN.kMDCContactsTotal[j][3] << " "; // col 4
	   	file << LN.kMDCContactsNaive[j] << " ";//col 5
	   	file << LN.kMDCContactsUnique[j] << " ";//col 6
	   	file << LN.kMDCContactsActiveUnique[j] << " ";//col 7
	   	file << LN.kMDCContactsCognate[j] << " ";//col 8
	   	file << LN.kMDCContactsNonCognate[j] << " "; //col 9
	   	file << LN.kMDCContactsNaiveCognate[j] << " "; // col 10   
	  	file << LN.kMDCBoundTotal[j] << " "; // col 11
	   	file << LN.kMDCActivatedTotal[j] << endl; // col 12
	}
	file.close();
	
	sprintf(str,"./data/LDCContactsWithKcells-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// Col 1 == DC id, col 2 == initial_pMHC of DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), col 4 == total kcell contacts(active/non-active, naive/non-naive), "
		 <<	"col 5== total Naive kcell contacts, col 6 == total unique naive kcell contacts, "
		 <<	 "col 7 == number active kcells contacting a unique dcell, col 8 == total contacts with cognate kcells, "
	     << "col 9 == total contacts with naive non-cognate kcells, col 10 == total contacts with naive cognate kcells, "
	     << "col 11 == total kcells bound to DC, col 12 == total kcells activated by DC"<< endl;
	        		 
	for (j = 0; j < LN.kLDCContactsTotal.size(); j++) {
		 file << LN.kLDCContactsTotal[j][0] << " "; // col 1
		 file << LN.kLDCContactsTotal[j][1] << " "; // col 2
		 file << LN.kLDCContactsTotal[j][2] << " "; // col 3
		 file << LN.kLDCContactsTotal[j][3] << " "; // col 4
		 file << LN.kLDCContactsNaive[j] << " ";//col 5
		 file << LN.kLDCContactsUnique[j] << " ";//col 6
		 file << LN.kLDCContactsActiveUnique[j] << " ";//col 7
		 file << LN.kLDCContactsCognate[j] << " ";//col 8
		 file << LN.kLDCContactsNonCognate[j] << " "; //col 9
		 file << LN.kLDCContactsNaiveCognate[j] << " "; // col 10   
		 file << LN.kLDCBoundTotal[j] << " "; // col 11
		 file << LN.kLDCActivatedTotal[j] << endl; // col 12
		}
	file.close();
																						
	sprintf(str, "./data/hcellPathLengths-%02d-%02d.txt", row, run);
	file.open(str);
	file << "Cells hit obstacles " << LN.brickWallCounter << " number of "
	     << "times. " << endl << endl;	
	file << "// The first 1000 hcells are recorded. The first row number is the time and the value in that row is the number of times an hcell has had that path length" << endl;  
	for (j = 0; j < LN.pathLengths.size(); j++) {
	  file << LN.pathLengths[j] << endl;
	}
	file.close();
	sprintf(str, "./data/searchTime-%02d-%02d.txt", row, run);
	file.open(str);
	file << "// The time it takes an hcell to find a DC from when it enters the LN in minutes (row number corresponds to minutes)." << endl;  
	file << "// We start at row 0" << endl;  
	for (j = 0; j < 1000; j++){ 
	  file << LN.searchTime[j] << endl; 
	}
	file.close();
	
	LN.Tcells_createdFile << LN.n_hcells << "\t" << LN.n_cog_hcells << "\t" << LN.n_kcells << "\t" << LN.n_cog_kcells << endl;


	cout <<"Total number of r_hcells created: " << LN.n_hcells << endl;  cout <<"Total number of cognate r_hcells created: " << LN.n_cog_hcells << endl;
	cout <<"Total number of r_hcells left LN: "<< LN.n_t4_cells_leave << endl;

	cout <<"Total number of r_kcells created: " << LN.n_kcells << endl;  cout <<"Total number of cognate r_kcells created: " << LN.n_cog_kcells << endl;
	cout <<"Total number of r_kcells left LN: "<< LN.n_t8_cells_leave << endl;
	      
      } // end for
   }
  // ****************************************************************************
    else if (argv[1][1]=='l') 
    {
      // read LHS matrix

      cout << endl;

      int numRuns = 0;
      if(argc > 3 && 'r' == argv[2][1])   // r = number of iterations (runs)
      {  
    	  numRuns = atoi(argv[3]);
    	  if(numRuns > 80)
    	  {
    	  // 80 is an arbitrarily chosen big number
    		  cout << "You have chosen to have more than 80 runs.  There is no reason to do more than 80 runs. " << endl;
    		  cout << "There will be 80 runs.  If you would like to do more than 80 runs, let Laura know." << endl;
    		  numRuns = 80;
    	  } // end if numRuns
      } // end if argc 
      
      cout << "There will be " << numRuns << " runs per set of parameters." << endl;

      int numSets = 0;
      if(argc > 5 && 's' == argv[4][1])
      { // s = total number of sets
    	  numSets = atoi(argv[5]);
      }
      cout << "There are " << numSets << " rows in the LHS matrix file." << endl;

      int upperLimit = 0; // for the subset
      int lowerLimit = 0; // for the subset
      if(argc > 8 && 'w' == argv[6][1]){  // w = subset of s
    	  lowerLimit = atoi(argv[7]);
    	  upperLimit = atoi(argv[8]);
    	  if(upperLimit < lowerLimit){ 
    		  swap(upperLimit, lowerLimit);
    	  }
      }
      cout << "This process will use set " << lowerLimit << " through set " << upperLimit << " inclusive of the LHS matrix." << endl;

      string lhsMatrixFileName = "lhs_Aug17.txt"; // matrix file
      if(argc > 10 && 'f' == argv[9][1]){
    	  lhsMatrixFileName = argv[10];
      }
      cout << "The name of the LHS matrix file is: " << lhsMatrixFileName << "." << endl;

      LN.SAVE_FRAME = false;
      LN.PROG = true;
      LN.CHRONIC = true;
      if(LN.PROG){
    	  cout << "I will print the timestep counter as I progress." << endl; 
      }
      else{
    	  cout << "I am not going to print the timestep counter as I progress.  If you would like me to, please change the PROG value in LNmain." << endl;
      }

      cout << "I should be printing data to the data subfolder." << endl;
      if(LN.SAVE_FRAME)
      {
    	  cout << "I am saving frames. I should be printing these frames to the frames subfolder of data." << endl << endl;
      }else
      {
    	  cout << "I am not saving frames. " << endl;
      }

      if(random){
    	  cout << "The random seed has not been set; the output of this run will be truly random. " << endl;
      }else
      {
    	  cout << "The random seed has been set.  Please comment out any line including /'rnd/' from LNmain, unless you are de-bugging. " << endl;
      }

      cout << endl;

      // LN.readParFile("LN.par"); This is done in LN's ctor

      lhsmatrix.open(lhsMatrixFileName.c_str());
      if(!lhsmatrix){
    	  cerr << "The LHS Matrix created from the file \"" << lhsMatrixFileName << "\" is invalid.  Exiting." << endl;
    	  exit(3);
      }
      
      for (i = 0; i < numSets; i++) // i is the total number of parameter sets(rows of matrix, value of argument s), 1 row corresponds to 1 run
      { 
         cout << "*************************" << endl;
	  cout << "Reading the matrix row: " << i+1 << endl;
    	  float num;  // to read float values
    	  int x;      // to read int  values
        
	// following 4 parameters are varied to decide the DC_recruitment
	  /*
	  lhsmatrix >> num;
    	  LN.p.setA(num);
    	  cout << "a: " << LN.p.A()  << endl;

	  lhsmatrix >> num;
    	  LN.p.setB(num);
    	  cout << "b: " << LN.p.B()  << endl;

	  lhsmatrix >> num;
    	  LN.p.setC(num);
    	  cout << "c: " << LN.p.C() << endl;

	  lhsmatrix >> num;
    	  LN.p.setD(num);
    	  cout << "d: " << LN.p.D() << endl;

	  LN.pMHC_decay = exp(log(0.5) / (30 * LN.p.pMHC_HALFLIFE()));  // if updated every 20 time steps
    	  cout << "pMHC decay: " << LN.pMHC_decay << endl;
	 */
	// following 10 parameters  are varied in lhs on 11/30/08
    	  
    	  lhsmatrix >> num;
    	  LN.p.setpMHC_HALFLIFE(num);
    	  cout << "pMHC_HALFLIFE: " << LN.p.pMHC_HALFLIFE() << endl;
    	  
    	  LN.pMHC_decay = exp(log(0.5) / (30 * LN.p.pMHC_HALFLIFE()));  // if updated every 20 time steps
    	  cout << "pMHC decay: " << LN.pMHC_decay << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setUNBINDING_THRESHOLD(num);
    	  cout << "UNBINDING_THRESHOLD: " << LN.p.UNBINDING_THRESHOLD() << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setpMHC_FOR_MEDIAN_BINDING_PROB_HCELL(num);
    	  cout << "pMHC_FOR_MEDIAN_BINDING_PROB_HCELL: " << LN.p.pMHC_FOR_MEDIAN_BINDING_PROB_HCELL() << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setSHAPE_BINDING_PROB_CURVE_HCELL(num);
    	  cout << "SHAPE_BINDING_PROB_CURVE_HCELL: " << LN.p.SHAPE_BINDING_PROB_CURVE_HCELL() << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setTIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL(num);
    	  cout << "TIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL: " << LN.p.TIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL() << " (" << LN.p.TIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL()/600 << " hrs)" << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setSHAPE_ACTIVATION_PROB_CURVE_HCELL(num);
    	  cout << "SHAPE_ACTIVATION_PROB_CURVE_HCELL: " << LN.p.SHAPE_ACTIVATION_PROB_CURVE_HCELL() << " (" << LN.p.SHAPE_ACTIVATION_PROB_CURVE_HCELL()/10 << ")" << endl;
    	  
    	  lhsmatrix >> num;
    	  LN.p.setpMHC_FOR_MEDIAN_BINDING_PROB_KCELL(num);
    	  cout << "pMHC_FOR_MEDIAN_BINDING_PROB_KCELL: " << LN.p.pMHC_FOR_MEDIAN_BINDING_PROB_KCELL() << endl;
    	      	  
    	  lhsmatrix >> num;
    	  LN.p.setSHAPE_BINDING_PROB_CURVE_KCELL(num);
    	  cout << "SHAPE_BINDING_PROB_CURVE_KCELL: " << LN.p.SHAPE_BINDING_PROB_CURVE_KCELL() << endl;
    	      	  
    	  lhsmatrix >> num;
    	  LN.p.setTIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL(num);
    	  cout << "TIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL: " << LN.p.TIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL() << " (" << LN.p.TIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL()/600 << " hrs)"<< endl;
    	      	  
    	  lhsmatrix >> num;
    	  LN.p.setSHAPE_ACTIVATION_PROB_CURVE_KCELL(num);
    	  cout << "SHAPE_ACTIVATION_PROB_CURVE_KCELL: " << LN.p.SHAPE_ACTIVATION_PROB_CURVE_KCELL() << " (" << LN.p.SHAPE_ACTIVATION_PROB_CURVE_KCELL()/10 << ")"<< endl;
    	  
	  /*
	  //  ******NEW PARAMETERS*****
	  lhsmatrix >> num;
	  LN.p.MAX_TIME_D_MATURE = num;
	  cout << "MAX_TIME_D_MATURE: " << LN.p.MAX_TIME_D_MATURE << endl;
	  
	  lhsmatrix >> num;
          LN.p.N_DIVISIONS_T4 = num;
	  cout << "N_DIVISIONS_T4: " << LN.p.N_DIVISIONS_T4 << endl;
	  LN.p.N_DIVISIONS_T8 = LN.p.N_DIVISIONS_T4;
	  cout << "N_DIVISIONS_T8: " << LN.p.N_DIVISIONS_T8 << endl;
	  
	  lhsmatrix >> num;
	  LN.p.aHCELL_DOUBLING_PERIOD = num;
	  cout << "aHCELL_DOUBLING_PERIOD: " << LN.p.aHCELL_DOUBLING_PERIOD << endl;
	  LN.p.aKCELL_DOUBLING_PERIOD = LN.p.aHCELL_DOUBLING_PERIOD;
	  cout << "aKCELL_DOUBLING_PERIOD: " << LN.p.aKCELL_DOUBLING_PERIOD << endl;
	  
	  lhsmatrix >> num;
      	  LN.p.PROB_H_RECRUITMENT = num;
    	  cout << "PROB_H_RECRUITMENT: " << LN.p.PROB_H_RECRUITMENT << endl; 

	  lhsmatrix >> num;
	  LN.p.PROB_K_RECRUITMENT = num;
    	  cout << "PROB_K_RECRUITMENT: " << LN.p.PROB_K_RECRUITMENT << endl;
          
	  lhsmatrix >> num;
	  LN.p.COGNATE_HCELL = num;
    	  cout << "COGNATE_HCELL: " << LN.p.COGNATE_HCELL << endl;
	  LN.p.COGNATE_KCELL = num;
    	  cout << "COGNATE_KCELL: " << LN.p.COGNATE_KCELL << endl;
          
	  lhsmatrix >> num;
	  LN.p.DCELL_TIME_BEING_LICENSED = num;
	  cout << "DCELL_TIME_BEING_LICENSED: " << LN.p.DCELL_TIME_BEING_LICENSED << endl; 

	  lhsmatrix >> num;
      	  LN.p.setPROB_eHELPER_LICENSES_MDC(num);
    	  cout << "PROB_eHELPER_LICENSES_MDC: " << LN.p.PROB_eHELPER_LICENSES_MDC() << endl; 
	  */
 	   
    	  if(lowerLimit <= i && i <= upperLimit)
    	  {
    		  printf("************************\n");
    		  for (j = 0; j < numRuns; j++)  // j is the number of runs with this particular set of parameters
    		  {
    			    
    			  // lhspulse.sta file
    			  sprintf(str, "./data/lhspulse-%02d-%02d.sta",i,j);	    
    			  LN.statfile.open(str);
    			  LN.statfile << "NRH" << "\t" << "NAH" << "\t" << "NEH" << "\t" << "NRK" << "\t" << "NAK"
    			  << "\t" << "NEK" << "\t" << "NMK" << "\t" <<"NID"<< "\t"<< "NMD" << "\t"
    			  << "NLD" << "\t" << "t4_o" << "\t" << "t4a_o" << "\t"
    			  << "t4e_o" << "\t" << "t8_o" << "\t" << "t8a_o" << "\t"
    			  << "t8e_o" << "\t" << "t8m_o" << endl;

			  sprintf(str,"./data/DC_recruitment-%02d-%02d.txt", i, j);
    	  		  LN.DC_recruitmentFile.open(str);
	  		  LN.DC_recruitmentFile << "Hour" << "\t" << "DC_recruitment" << "\t" << "MDC" << "\t" << "LDC" << "\t" << "MDC+LDC" << "\t" << "Total_DC" << endl;
    			  printf("************ Row number: %d Run number: %d *******************\n", i , j );   
    			  // *******************************************
    			  LN.run();
    			  // *******************************************
    			  LN.statfile.close();
    			  LN.DC_recruitmentFile.close();
			   // hCognate.txt file
    			  sprintf(str, "./data/hCognate-%02d-%02d.txt", i,j);
    			  file.open(str);
                          file << "Cog_h_id" << "\t" << "binding_prob" << "\t" << "bound" << "\t" << "activation_prob" << "\t" 
		          << "activated" << "\t" << "activation_time" << "\t" << "searchTime" << "\t" << "transitTime" << endl;
      			  for ( int i = 0; i < LN.hCognate.size(); i++)
	  		  {
              //if ( LN.hCognate[i][0] > ((LN.p.INITIAL_rHELPERT_CELLS()*3) - 1) ) // recruited hcells only
	          		file << LN.hCognate[i][0] << "\t" << LN.hCognate[i][1] << "\t"
	               		<< LN.hCognate[i][2] << "\t" << LN.hCognate[i][3] << "\t"  
	               		<< LN.hCognate[i][4] << "\t" << LN.hCognate[i][5] << "\t"
			 	<< LN.hCognate[i][6] << "\t" << LN.hCognate[i][7] << endl;
	  		  }          
    			  
    			  file.close();
    			  
    			  // kCognate.txt file
    			  sprintf(str, "./data/kCognate-%02d-%02d.txt", i, j);
    			  file.open(str);
			  file << "Cog_k_id" << "\t" << "binding_prob" << "\t" << "bound" << "\t" << "activation_prob" << "\t" 
			  << "activated" << "\t" << "activation_time" << "\t" << "searchTime" << "\t" << "transitTime" << endl;
	  		  for ( int i = 0; i < LN.kCognate.size(); i++)
	  		  {
	           //if ( LN.kCognate[i][0] > ((LN.p.INITIAL_rKILLERT_CELLS()*3) - 2) ) // recruited hcells only
	  	          file << LN.kCognate[i][0] << "\t" << LN.kCognate[i][1] << "\t"
	  	          	 << LN.kCognate[i][2] << "\t" << LN.kCognate[i][3] << "\t"
	  	               << LN.kCognate[i][4] << "\t" << LN.kCognate[i][5] << "\t"
				 << LN.kCognate[i][6] << "\t" << LN.kCognate[i][7] << endl;
	  		  }          
    			  
    			  file.close();

    			  // lifetimeDisplacement.txt file
    			  sprintf(str, "./data/lifetimeDisplacement-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// row numberis how far a cell is from its entrance when it dies, exits, or the simulation ends. "
    			  << "This distance is measured in microcompartments." << endl;
    			  for(int k = 0; k < LN.lifetimeDisplacement.size(); k++){
    				  file << LN.lifetimeDisplacement[k] << endl;
    			  }
    			  file.close();
    			  
    			  sprintf(str,"./data/transitTimes-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// row number is how long it takes the cell to leave in tenths of hours" << endl;
    			  for (int k = 0; k < 960; k++) {
    				  file << LN.histo[k] << endl;
    			  }
    			  file.close();
    			   
    			  // MDCContactsWithHcells.txt
    			  sprintf(str,"./data/MDCContactsWithHcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, "
    				   //<< "col 2 == initial pMHC on DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), 
    			       << "col 2 == total hcell contacts(active/non-active, naive/non-naive), "
    			  	   << "col 3 == total Naive hcell contacts, col 4== total unique naive hcell contacts, "
    			  	   << "col 5 == number active hcells contacting a unique dcell, col 6 == total contacts with cognate hcells, "
    			  	   <<"col 7 == total contacts with naive non-cognate hcells, col 8 == total contacts with naive cognate hcells, " 
    			  	   //<< "col 11== total number of hcells bound, col 12 == total number of hcells activated" 
    			  	   << endl;  
    			  for (int k = 0; k < LN.hMDCContactsTotal.size(); k++) {
    			  	
    			  		file << LN.hMDCContactsTotal[k][0] << " "; // col 1
    			  	    //file << LN.hMDCContactsTotal[k][1] << " "; // col 2
    			  	    //file << LN.hMDCContactsTotal[k][2] << " "; // col 3
    			  	    file << LN.hMDCContactsTotal[k][3] << " "; // col 4
    			  	    file << LN.hMDCContactsNaive[k] << " ";//col 5
    			  	    file << LN.hMDCContactsUnique[k] << " ";//col 6
    			  	    file << LN.hMDCContactsActiveUnique[k] << " ";//col 7
    			  	    file << LN.hMDCContactsCognate[k] << " ";//col 8
    			  	    file << LN.hMDCContactsNonCognate[k] << " "; //col 9    
    			  	    file << LN.hMDCContactsNaiveCognate[k] << " "; // col 10 
    			  	    //file << LN.hMDCBoundTotal[k] << " "; // col 11
    			  	    //file << LN.hMDCActivatedTotal[k] << ; // col 12
    			  	    file << endl;
    			  } 
    			  file.close();

    			  // LDCContactsWithHcells.txt
    			  sprintf(str,"./data/LDCContactsWithHcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, "
    				   	 //<< "col 2 == initial pMHC on DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), 
    			  		 << "col 2 == total hcell contacts(active/non-active, naive/non-naive), "
    			         <<  "col 3 == total Naive hcell contacts, col 4 == total unique naive hcell contacts, "
    			  	     << "col 5 == number active hcells contacting a unique dcell, col 6 == total contacts with cognate hcells, "
    			  	     << "col 7 == total contacts with naive non-cognate hcells, col 8== total contacts with naive cognate hcell" 
    			  	     //<< "col 11== total number of hcells bound, col 12 == total number of hcells activated" 
    			  	     << endl;
    			  for (int k = 0; k < LN.hLDCContactsTotal.size(); k++) {
    			  		file << LN.hLDCContactsTotal[k][0] << " "; // col 1  
    			    	//file << LN.hLDCContactsTotal[k][1] << " "; // col 2   
    			     	//file << LN.hLDCContactsTotal[k][2] << " "; // col 3     
    			       	file << LN.hLDCContactsTotal[k][3] << " "; // col 4     
    			       	file << LN.hLDCContactsNaive[k] << " ";//col 5           
    			  	   	file << LN.hLDCContactsUnique[k] << " ";//col 6        
    			  		file << LN.hLDCContactsActiveUnique[k] << " ";//col 7        
    			  		file << LN.hLDCContactsCognate[k] << " ";//col 8         
    			  	 	file << LN.hLDCContactsNonCognate[k] << " "; //col 9       
    			        file << LN.hLDCContactsNaiveCognate[k] << " "; // col 10       
    			        //file << LN.hLDCBoundTotal[k] << " "; // col 11       
    			        //file << LN.hLDCActivatedTotal[k] ; // col 12
    			        file << endl;
    			  }
    			  file.close();

    			  // MDCContactsWithKcells.txt
    			  sprintf(str,"./data/MDCContactsWithKcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, "
    				   //<<  "col 2 == initial_pMHC of DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), 
    			       << "col 2 == total kcell contacts(active/non-active, naive/non-naive), "
    			  	   << "col 3== total Naive kcell contacts, col 4 == total unique naive kcell contacts, "
    			  	   << "col 5 == number active kcells contacting a unique dcell, col 6 == total contacts with cognate kcells, "
    			       << "col 7 == total contacts with naive non-cognate kcells, col 8 == total contacts with naive cognate kcells, "
    			       //<< "col 11 == total kcells bound to DC, col 12 == total kcells activated by DC"
    			       << endl;
    			          		 
    			  for (int k = 0; k < LN.kMDCContactsTotal.size(); k++) {
    			  	   	file << LN.kMDCContactsTotal[k][0] << " "; // col 1
    			  	   	//file << LN.kMDCContactsTotal[k][1] << " "; // col 2
    			  	   	//file << LN.kMDCContactsTotal[k][2] << " "; // col 3
    			  	   	file << LN.kMDCContactsTotal[k][3] << " "; // col 4
    			  	   	file << LN.kMDCContactsNaive[k] << " ";//col 5
    			  	   	file << LN.kMDCContactsUnique[k] << " ";//col 6
    			  	   	file << LN.kMDCContactsActiveUnique[k] << " ";//col 7
    			  	   	file << LN.kMDCContactsCognate[k] << " ";//col 8
    			  	   	file << LN.kMDCContactsNonCognate[k] << " "; //col 9
    			  	   	file << LN.kMDCContactsNaiveCognate[k] << " "; // col 10   
    			  	  	//file << LN.kMDCBoundTotal[k] << " "; // col 11
    			  	   	//file << LN.kMDCActivatedTotal[k] ; // col 12
    			  	   	file << endl;
    			  }
    			  file.close();
    			  	
    			  // LDCContactsWithKcells.txt
    			  sprintf(str,"./data/LDCContactsWithKcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, "
    					 // "col 2 == initial_pMHC of DC, col3 == DC state (1=MDC, 2=LDC, 3=DEAD), "
    					 << "col 2 == total kcell contacts(active/non-active, naive/non-naive), "
    			  		 <<	"col 3== total Naive kcell contacts, col 4 == total unique naive kcell contacts, "
    			  		 <<	 "col 5 == number active kcells contacting a unique dcell, col 6 == total contacts with cognate kcells, "
    			  	     << "col 7 == total contacts with naive non-cognate kcells, col 8 == total contacts with naive cognate kcells, "
    			  	     //<< "col 11 == total kcells bound to DC, col 12 == total kcells activated by DC"
    			  	     << endl;
    			  	        		 
    			  for (int k = 0; k < LN.kLDCContactsTotal.size(); k++) {
    			  		 file << LN.kLDCContactsTotal[k][0] << " "; // col 1
    			  		 //file << LN.kLDCContactsTotal[k][1] << " "; // col 2
    			  		 //file << LN.kLDCContactsTotal[k][2] << " "; // col 3
    			  		 file << LN.kLDCContactsTotal[k][3] << " "; // col 4
    			  		 file << LN.kLDCContactsNaive[k] << " ";//col 5
    			  		 file << LN.kLDCContactsUnique[k] << " ";//col 6
    			  		 file << LN.kLDCContactsActiveUnique[k] << " ";//col 7
    			  		 file << LN.kLDCContactsCognate[k] << " ";//col 8
    			  		 file << LN.kLDCContactsNonCognate[k] << " "; //col 9
    			  		 file << LN.kLDCContactsNaiveCognate[k] << " "; // col 10   
    			  		 //file << LN.kLDCBoundTotal[k] << " "; // col 11
    			  		 //file << LN.kLDCActivatedTotal[k] ; // col 12
    			  		 file << endl;
    			  		}
    			  file.close();
    			 /* sprintf(str, "./data/MDCContactsWithHcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, col 2 == total hcell contacts(active/non-active, naive/non-naive), col 3 == total Naive hcell contacts, "
    			  << "col 4 == total unique naive hcell contacts, col 5 == number active hcells contacting a unique dcell, col 6 == total contacts "
    			  << "with naive cognate hcells, and col 7 == total contacts with naive non-cognate hcells, col 8 == total contacts with naive "
    			  << "cognate hcells"<< endl;  
    			  for (int k = 0; k < LN.hMDCContactsTotal.size(); k++) 
    			  {
    				  for(int m = 0; m < 2; m++){
    					  file << LN.hMDCContactsTotal[k][m] << " ";
    				  }
    				  file << LN.hMDCContactsNaive[k] << " ";//col 3
    				  file << LN.hMDCContactsUnique[k] << " ";//col 4
    				  file << LN.hMDCContactsActiveUnique[k] << " ";//col 5
    				  file << LN.hMDCContactsCognate[k] << " ";//col 6
    				  file << LN.hMDCContactsNonCognate[k] << " "; //col 7    
    				  file << LN.hMDCContactsNaiveCognate[k] << " "<< endl; // col 8   
    			  } 
    			  file.close();
	    
    			  sprintf(str, "./data/MDCContactsWithKcells-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// Col 1 == DC id, col 2 == total kcell contacts(active/non-active, naive/non-naive), col 3 == total Naive kcell contacts, "
    			  << "col 4 == total unique naive kcell contacts, col 5 == number active kcells contacting a unique dcell, col 6 == total contacts "
    			  << "with naive cognate kcells, and col 7 == total contacts with naive non-cognate kcells, col 8 == total contacts with naive " 
    			  << "cognate kcells"<< endl;
    			  for (int k = 0; k < LN.kMDCContactsTotal.size(); k++) 
    			  {
    				  for(int m = 0; m < 2; m++){
    					  file << LN.kMDCContactsTotal[k][m] << " ";
    				  }
    				  file << LN.kMDCContactsNaive[k] << " ";//col 3
    				  file << LN.kMDCContactsUnique[k] << " ";//col 4
    				  file << LN.kMDCContactsActiveUnique[k] << " ";//col 5
    				  file << LN.kMDCContactsCognate[k] << " ";//col 6
    				  file << LN.kMDCContactsNonCognate[k] << " "; //col 7    
    				  file << LN.kMDCContactsNaiveCognate[k] << " "<< endl; // col 8   
    			  }
    			  file.close(); */
	    
    			  sprintf(str, "./data/hcellPathLengths-%02d-%02d.txt", i, j);
    			  file.open(str);
	    
    			  file << "// The first 1000 hcells are recorded. The first row number is the time and the value in that row is the number of " 
    			  << "times an hcell has had that path length" << endl;  
    			  for (int k = 0; k < LN.pathLengths.size(); k++) {
    				  file << LN.pathLengths[k] << endl;
    			  }
    			  file.close();
	   
    			  sprintf(str, "./data/searchTime-%02d-%02d.txt", i, j);
    			  file.open(str);
    			  file << "// The time it takes an hcell to find a DC from when it enters the LN in minutes (row number corresponds to minutes)." << endl;  
    			  file << "// We start at row 0" << endl;  
    			  for (int k = 0; k < 1000; k++){ 
    				  file << LN.searchTime[k] << endl; 
    			  } 
    			  file.close();
    		  } // end for j < numRuns
    	  } // end if i is between lowerLimit and upperLimit, inclusive.
      } // end for i < numSets
      lhsmatrix.close();
    } // end else if argv[1][1]=='l'
  } // end if argc>=2
  
  //cout <<"Total number of r_hcells created: " << LN.n_hcells << endl;
  //cout <<"Total number of cognate r_hcells created: " << LN.n_cog_hcells << endl;  
  //cout <<"Total number of r_hcells left LN: "<< LN.n_t4_cells_leave << endl;

  //cout <<"Total number of r_kcells created: " << LN.n_kcells << endl;
  //cout <<"Total number of cognate r_kcells created: " << LN.n_cog_kcells << endl;
  //cout <<"Total number of r_kcells left LN: "<< LN.n_t8_cells_leave << endl;
  
  time_t endtime = time(NULL);
  int total_time = (int)difftime(endtime, begtime); 
  int endhour = total_time / 3600;
  total_time = total_time % 3600;
  int endmin = total_time / 60;
  int endsec = total_time % 60;
  
  printf("Total Time : %dh %dm %ds\n", endhour, endmin, endsec); 
} // main



