#include "LN.h"
#include <math.h>

double Tcell::calcDist(int row, int col)
{
  double x = (double)((birthRow - row));
  double y = (double)((birthCol - col));
  double xx = x * x;
  double yy = y * y;
    
  return sqrt(xx + yy);
}

void LymphNode::remove_dead_cells() 
{
  cellpos *cp; // save memory to re-use this variable

  for (int i = LH.size() - 1; i >= 0; i--) {
	  cp = LH.elem(i);
    //if(counter - cp->cell_pointer->birthtime >= p.MAX_H_CELL_AGE || (H_EFFECTOR == cp->cell_pointer->state && counter - cp->cell_pointer->birthtime >= p.MAX_TIME_H_EFFECTOR)){
      if (cp->cell_pointer->state == H_DEAD) {

      // add to pathLengths
    	  if(((Tcell*)cp->cell_pointer)->inFirstThousandTCells // within data set
    			  && ((Tcell*)cp->cell_pointer)->persistentPath != NONE // otherwise already counted
    			  && ((Tcell*)cp->cell_pointer)->persistentPathLength > 0 // otherwise already counted
    			  && ((Tcell*)cp->cell_pointer)->persistentPathLength < pathLengths.size()){ // within bounds of vector
    		  pathLengths[((Tcell*)cp->cell_pointer)->persistentPathLength]++; 
    	  }
    	  if(((Tcell*)cp->cell_pointer)->inFirstThousandTCells){
    		  lifetimeDisplacement[(int)((Tcell*)cp->cell_pointer)->calcDist(cp->row, cp->col)]++;
    	  }

    	  int pos = M[cp->row][cp->col].find_cell(cp->cell_pointer);
    	  if(pos != -1){
    		  M[cp->row][cp->col].shift_cells(pos);
    	  }else{
    		  cerr << "Could not find LH's " << i << "th cell in Matrix. " << endl;
    	  }
    	  ((Tcell*)(cp)->cell_pointer)->dcContacted.clear();
    	  ((Tcell*)(cp)->cell_pointer)->dcContactedActive.clear();
    	  if(int dcID = ((Tcell*)cp->cell_pointer)->bound_to_dcell){
    		  int pos = LD.whereis(dcID);
    		  if(pos != -1){
    			  ((d_cell*)((LD.elem(pos)->cell_pointer)))->remove_tcell(cp->cell_pointer->id);
    		  }else{
    			  cerr << "Could not find hcell's attached dcell " << dcID << endl;
    		  }
    	  }
    	  if(M[cp->row][cp->col].find_cell(cp->cell_pointer) != -1){
    		  M[cp->row][cp->col].shift_cells( M[cp->row][cp->col].find_cell(cp->cell_pointer) );
    	  }
    	  LH.erase(cp);
    	  if(i < LH.size() - 1) {
    		  i++;
    	  }
      }
  }

  for(int i = LK.size() - 1; i >= 0; i--) {
    cp = LK.elem(i);
    //if(K_MEMORY != cp->cell_pointer->state && 
       //(counter - cp->cell_pointer->birthtime >= p.MAX_K_CELL_AGE || (K_EFFECTOR == cp->cell_pointer->state && counter - cp->cell_pointer->birthtime >= p.MAX_TIME_K_EFFECTOR))){
    if (cp->cell_pointer->state == K_DEAD) {

      // add to pathLengths
      if(((Tcell*)cp->cell_pointer)->inFirstThousandTCells // within data set
    		  && ((Tcell*)cp->cell_pointer)->persistentPath != NONE // otherwise already counted
    		  && ((Tcell*)cp->cell_pointer)->persistentPathLength > 0 // otherwise already counted
    		  && ((Tcell*)cp->cell_pointer)->persistentPathLength < pathLengths.size()){ // within bounds of vector
    	  pathLengths[((Tcell*)cp->cell_pointer)->persistentPathLength]++; 
      }

      int pos = M[cp->row][cp->col].find_cell(cp->cell_pointer);
      if(pos != -1){
    	  M[cp->row][cp->col].shift_cells(pos);
      }
      else{
    	  cerr << "Could not find LK's " << i << "th cell in Matrix. " << endl;
      }
      ((Tcell*)(cp)->cell_pointer)->dcContacted.clear();
      ((Tcell*)(cp)->cell_pointer)->dcContactedActive.clear();
      if(int dcID = ((Tcell*)cp->cell_pointer)->bound_to_dcell){
	int pos = LD.whereis(dcID);
	if(-1 != pos){
	  ((d_cell*)((LD.elem(pos)->cell_pointer)))->remove_tcell(cp->cell_pointer->id);
	}else{
	  cerr << "Could not find kcell's attached dcell " << dcID << endl;
	}
      }
      if(M[cp->row][cp->col].find_cell(cp->cell_pointer) != -1){
	M[cp->row][cp->col].shift_cells( M[cp->row][cp->col].find_cell(cp->cell_pointer) );
      }
      LK.erase(cp);
      if(i < LK.size() - 1){
	i++;
      } 
    } 
  } 

  for (int i = LD.size() - 1; i >= 0; i--) {
    cp = LD.elem(i); 
    if (cp->cell_pointer->state == D_DEAD) {
      M[cp->row][cp->col].cell[0] = NULL;
      for(int j = 0; j < microcompartment::NUM_CELLS; j++){
	if(M[cp->row][cp->col].cell[j] != NULL){
	  cerr << "Den cell didn't cover whole microcompartment " << i << " " << cp->row << " " << cp->col << " " << j << " " << M[cp->row][cp->col].cell[j]->id << " " << M[cp->row][cp->col].cell[j]->is_dcell() << endl;
	  // exit(78);
	}
      }
      for(int k = ((d_cell*)(cp->cell_pointer))->tbind.size()-1; k >= 0; k--){
	int tcell = ((d_cell*)(cp->cell_pointer))->tbind[k];
	if(tcell % 3 == 2){
	  int pos = LH.whereis(tcell);
	  if(pos != -1){
	    Cell* cell = (LH.elem(pos))->cell_pointer;
	    ((Tcell*)(cell))->bound_to_dcell = 0;
	  }else{
	    cerr << "hcell: " << tcell << " not removed from tbind." << endl;
	  }
	}else if(tcell % 3 == 1){
	  int pos = LK.whereis(tcell);
	  if(pos != -1){
	    Cell* cell = (LK.elem(pos))->cell_pointer;
	    ((Tcell*)(cell))->bound_to_dcell = 0;
	  }else{
	    cerr << "kcell: " << tcell << " not removed from tbind. " << endl;
	  }
	}else{
	  cerr << "Not a valid tcell id in delete_dcell. Exiting." << endl;
	  exit(34);
	}
      }
      M[cp->row][cp->col].shift_cells( 0 ); // 0 is the position of a dcell
     // cout << "**Removing dead DC**" << endl;
      LD.erase(cp);
      if(i < LD.size() - 1){
	i++;
      } 
    } 
  }  
}

void checkRowsAndCols(int row, int col, string msg)
{
  if(!withinRowsAndCols(row, col)){
    cerr << msg << endl;
    cerr << "Invalid coordinates." << " row is " << row << ". " << "row must be between " << 0;
    cerr << " and " << MROWS << ". " << "col is " << col << ". " << "col must be between " << 0;
    cerr << " and " << MCOLS << ". " << "Exiting. " << endl;
    exit(13);
  }
}

bool withinRowsAndCols(int row, int col)
{
  return (0 <= row && row < MROWS && 0 <= col && col < MCOLS);
}

bool LymphNode::freeAndExistingSite(int row, int col)
{
  return (withinRowsAndCols(row, col) && M[row][col].free_site());
}

// this function defines the probability distribution for motion of 
// tcells. Each neighbor compartment, except backwards, (no diagonal) is assigned a 
// probability every step.
void LymphNode::find_most_probable_row_col(const cellpos* cpos, int& newrow, int& newcol) 
{
  float prob = rnd.Next(0,10000)/100.0;
  float bias = 25;  // bias = 25 = no bias
  int jumpto = 0; // which of the four cardinal directions the cell will move to
  int pdir = ( ((Tcell *)cpos->cell_pointer)->direction ) % 5; // 

  if(pdir == 0) {
    if(prob <= 25 /*bias*/){
      jumpto = 4;
    }else if(prob <= 50 /*bias + (100 - bias) / 3*/){
      jumpto = 3;
    }else if(prob <= 75 /*bias + (100 - bias) * 2 / 3*/){
      jumpto = 2;
    }else{
      jumpto = 1;
    }
  }else if(pdir == 1){
    if(prob <= 33.33){
      jumpto = 4;
    }else if(prob <= 66.66){
      jumpto = 2;
    }else{
      jumpto = 1;
    }
  }else if(pdir == 2){
    if(prob <= 33.33){
      jumpto = 3;
    }else if(prob <= 66.66){
      jumpto = 1;
    }else{
      jumpto = 2;
    }
  }else if(pdir == 3){
    if(prob <= 33.33){
      jumpto = 4;
    }else if(prob <= 66.66){ 
      jumpto = 2;
    }else{
      jumpto = 3;
    }
  }else if(pdir == 4){
    if(prob <= 33.33){
      jumpto = 4;
    }else if(prob <= 66.66){
      jumpto = 3;
    }else{  
      jumpto = 1;
    }
  }
  
  // save the direction chosen for future reference
  ((Tcell *)cpos->cell_pointer)->direction = jumpto;   
  
  if (jumpto == 1){
    newrow = cpos->row;
    newcol = cpos->col + 1;
  }else if (jumpto == 2){
    newrow = cpos->row + 1;
    newcol = cpos->col;
  }else if (jumpto == 3){
    newrow = cpos->row;
    newcol = cpos->col - 1;
  }else if (jumpto == 4){
    newrow = cpos->row - 1;
    newcol = cpos->col;
  }
  
  // make sure the new position is between boundaries
  // make the grid a cylindrical torus
  if(newrow < 0) 
    newrow = 0;
  if(newrow >= MROWS) 
    newrow = MROWS - 1;
  if(newcol < 0) 
    newcol = MCOLS - 1;
  if(newcol >= MCOLS) 
    newcol = 0;

  DIRECTIONS jumptoDirection = NONE;
  switch(jumpto){
  case 1: jumptoDirection = EAST; 
    break;
  case 2: jumptoDirection = SOUTH; 
    break;
  case 3: jumptoDirection = WEST; 
    break;
  case 4: jumptoDirection = NORTH; 
    break;
  default: jumptoDirection = NONE; 
    break;
  } 

  // keep track of the persistentPath and its length
  if(cpos->cell_pointer->is_tcell() && ((Tcell*)cpos->cell_pointer)->inFirstThousandTCells){
    if(!M[newrow][newcol].is_empty()){ // I have met an obstacle
      if(((Tcell*)cpos->cell_pointer)->persistentPathLength < pathLengths.size()){
	pathLengths[((Tcell*)cpos->cell_pointer)->persistentPathLength]++;
      }
      ((Tcell*)cpos->cell_pointer)->persistentPath = NONE;
      ((Tcell*)cpos->cell_pointer)->persistentPathLength = 0;
      brickWallCounter++;
    }
    if(((Tcell*)cpos->cell_pointer)->persistentPath == jumptoDirection){
      ((Tcell*)cpos->cell_pointer)->persistentPathLength++;
    }else{
      if(((Tcell*)cpos->cell_pointer)->persistentPathLength < pathLengths.size()){
	pathLengths[((Tcell*)cpos->cell_pointer)->persistentPathLength]++;
      }
      ((Tcell*)cpos->cell_pointer)->persistentPath = jumptoDirection;
      ((Tcell*)cpos->cell_pointer)->persistentPathLength = 1;
    }
  }
}

