#ifndef LN_PAR_H
#define LN_PAR_H

using namespace std;

class Par{
 private:
  int ndays; // simulation time

  int initial_rhelpert_cells;
  int initial_ahelpert_cells;
  int initial_ehelpert_cells;
  int initial_rkillert_cells;
  int initial_akillert_cells;
  int initial_mkillert_cells;
  int initial_dendritic_cells;
  
  //int initial_mdendritic_cells;
  //int initial_ldendritic_cells;
   
  // parameters to calculate the DC_recruitment
  double a;
  double b;
  double c;
  double d;

  float prob_ehelper_licenses_mdc;
  //float prob_rhelper_licenses_mdc;
  
  double pMHC_halflife;  // decay in #pMHC 
  float unbinding_threshold; // tcell becomes unbound below this value
  float binding_threshold; // min #pMHC on DC needed for binding
  float idc_mdc_boundary; // whether a DC is mature or immature
  
  double decay_tcell_contact_history;
  double decay_tcell_binding_history;  
  
  float pMHC_for_median_binding_prob_hcell; 
  float shape_binding_prob_curve_hcell;
  float time_for_median_activation_prob_hcell;
  float shape_activation_prob_curve_hcell;
  
  float pMHC_for_median_binding_prob_kcell; 
  float shape_binding_prob_curve_kcell;
  float time_for_median_activation_prob_kcell;
  float shape_activation_prob_curve_kcell;
  
  //float prob_ldc_matures_dc;  
  //float prob_mdc_matures_idc;
  //float prob_ptc_matures_idc;
  float prob_ak_becomes_mk;
  
  float prob_h_enhanced_recruitment;
  float prob_k_enhanced_recruitment;
  float prob_dc_enhanced_recruitment;

  //float prob_binding_primed_t4_with_idc;
  float prob_binding_t4_with_dc;
  float prob_binding_t8_with_ldc;
  float prob_dc_activates_t4;
  float prob_ldc_activates_t8;

  float prob_h_recruitment;
  float prob_k_recruitment;
  float prob_d_recruitment;

  int hcell_time_being_active;
  int kcell_time_being_active;
  int dcell_time_being_licensed;

  //int total_den_cells;
  //int peak_iden_cells;
  int peak_den_cells;

 public:

  float PROB_H_RECRUITMENT;
  float PROB_K_RECRUITMENT;
  float PROB_D_RECRUITMENT;
  
  int HCELL_TIME_BEING_ACTIVE; // = 28800; 
  int KCELL_TIME_BEING_ACTIVE; //=  28800; // 200000;
  int DCELL_TIME_BEING_LICENSED; // =  28800; //  100000;
  int aHCELL_DOUBLING_PERIOD;
  int aKCELL_DOUBLING_PERIOD;
  
  int MIN_H_CELL_AGE; // = 2376000; // 165 days 
  int MAX_H_CELL_AGE; // = 5256000; // 365 days 
  int MAX_TIME_H_EFFECTOR; // = 28800; // 2 days
  int MAX_TIME_K_EFFECTOR; // = 28800; // 2 days
  int MAX_TIME_D_MATURE; // = 28800
  
  int MIN_K_CELL_AGE; // = 2376000;
  int MAX_K_CELL_AGE; // = 5256000;
  int MIN_D_CELL_AGE; //= 14400; // 1 day 
  int MAX_D_CELL_AGE; //= 158400; // 11 days 
  
  //int MAX_TIME_NOT_MOVE; //=  9000; // 15 hours 
  //int MIN_TIME_NOT_MOVE; //= 6000;  // 10 hours
  //int TIME_REST_T4_LICENSES_MDC; // = 8700; //14.5 hours 

  //int MAX_TIME_pTC_BOUND_TO_DC; //= 900 // 90 min
  //int MIN_TIME_pTC_BOUND_TO_DC; //= 300 // 30 min
  
  int N_DIVISIONS_T4; // = 4; 
  int N_DIVISIONS_T8; // = 8;
  int N_TCELL_BIND_DC; // = 16;
  
  int COGNATE_KCELL; //= 10 The percent of cognate kcells (eg 10%) 
  int COGNATE_HCELL; //= 10 The percent of cognate hcells (eg 10%) 

  // get and set functions for the private attributes of class Par, set functions are called in LN::readParFile()
  int NDAYS(){
    return ndays;
  } 

  void setNDAYS(int num){
    ndays = num;
  }

  int INITIAL_rHELPERT_CELLS(){
    return initial_rhelpert_cells;
  }

  void setINITIAL_rHELPERT_CELLS(int num){
    initial_rhelpert_cells = num;
  }

  int INITIAL_aHELPERT_CELLS(){
    return initial_ahelpert_cells;
  }

  void setINITIAL_aHELPERT_CELLS(int num){
    initial_ahelpert_cells = num;
  } 

  int INITIAL_eHELPERT_CELLS(){
    return initial_ehelpert_cells;
  }

  void setINITIAL_eHELPERT_CELLS(int num){
    initial_ehelpert_cells = num;
  }

  int INITIAL_rKILLERT_CELLS(){
    return initial_rkillert_cells;
  }

  void setINITIAL_rKILLERT_CELLS(int num){
    initial_rkillert_cells = num;
  }

  int INITIAL_aKILLERT_CELLS(){
    return initial_akillert_cells;
  }

  void setINITIAL_aKILLERT_CELLS(int num){
    initial_akillert_cells = num;
  }

  int INITIAL_mKILLERT_CELLS(){
    return initial_mkillert_cells;
  }

  void setINITIAL_mKILLERT_CELLS(int num){
    initial_mkillert_cells = num;
  }

  int INITIAL_DENDRITIC_CELLS(){
    return initial_dendritic_cells;
  }

  void setINITIAL_DENDRITIC_CELLS(int num){
    initial_dendritic_cells = num;
  }

  double A(){
    return a;
  }

  void setA(double num){
    a = num;
  }
  
  double B(){
    return b;
  }

  void setB(double num){
    b = num;
  }

  double C(){
    return c;
  }

  void setC(double num){
    c = num;
  }
  
  double D(){
    return d;
  }

  void setD(double num){
    d = num;
  }

  //int INITIAL_mDENDRITIC_CELLS(){
  //  return initial_mdendritic_cells;
  //}

  //void setINITIAL_mDENDRITIC_CELLS(int num){
  //  initial_mdendritic_cells = num;
  //}

  //int INITIAL_lDENDRITIC_CELLS(){
  //  return initial_ldendritic_cells;
  //}

  //void setINITIAL_lDENDRITIC_CELLS(int num){
  //  initial_ldendritic_cells = num;
  //}

  float PROB_eHELPER_LICENSES_MDC(){
    return prob_ehelper_licenses_mdc;
  }

  void setPROB_eHELPER_LICENSES_MDC(float num){
    prob_ehelper_licenses_mdc = num;
  }
  
  double pMHC_HALFLIFE(){
      return pMHC_halflife;
  }
  void setpMHC_HALFLIFE(double num){
       pMHC_halflife = num;
  }
  
  float UNBINDING_THRESHOLD(){
       return unbinding_threshold;
  }
  void setUNBINDING_THRESHOLD(float num){
       unbinding_threshold = num;
  }
    
  float BINDING_THRESHOLD(){
       return binding_threshold;
  }
  void setBINDING_THRESHOLD(float num){
       binding_threshold = num;
  }
  
  double DECAY_TCELL_CONTACT_HISTORY(){
          return decay_tcell_binding_history;
  }
  void setDECAY_TCELL_CONTACT_HISTORY(double num){
          decay_tcell_binding_history = num;
  }
  
  double DECAY_TCELL_BINDING_HISTORY(){
        return decay_tcell_binding_history;
  }
  void setDECAY_TCELL_BINDING_HISTORY(double num){
        decay_tcell_binding_history = num;
  }
  
  float IDC_MDC_BOUNDARY(){
       return idc_mdc_boundary;
  }
  void setIDC_MDC_BOUNDARY(float num){
       idc_mdc_boundary = num;
  }
  
  float pMHC_FOR_MEDIAN_BINDING_PROB_HCELL(){
       return pMHC_for_median_binding_prob_hcell;
  }
  void setpMHC_FOR_MEDIAN_BINDING_PROB_HCELL(float num){
       pMHC_for_median_binding_prob_hcell = num;
  }
  
  float SHAPE_BINDING_PROB_CURVE_HCELL(){
       return shape_binding_prob_curve_hcell;
  }
  void setSHAPE_BINDING_PROB_CURVE_HCELL(float num){
       shape_binding_prob_curve_hcell = num;
  }
  
  float TIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL(){
       return time_for_median_activation_prob_hcell;
  }
  void setTIME_FOR_MEDIAN_ACTIVATION_PROB_HCELL(float num){
       time_for_median_activation_prob_hcell = num;
  } 
  
  float SHAPE_ACTIVATION_PROB_CURVE_HCELL(){
       return shape_activation_prob_curve_hcell;
  }
  void setSHAPE_ACTIVATION_PROB_CURVE_HCELL(float num){
       shape_activation_prob_curve_hcell = num;
  } 
  
  float pMHC_FOR_MEDIAN_BINDING_PROB_KCELL(){
       return pMHC_for_median_binding_prob_kcell;
  }
  void setpMHC_FOR_MEDIAN_BINDING_PROB_KCELL(float num){
       pMHC_for_median_binding_prob_kcell = num;
  }
  
  float SHAPE_BINDING_PROB_CURVE_KCELL(){
       return shape_binding_prob_curve_kcell;
  }
  void setSHAPE_BINDING_PROB_CURVE_KCELL(float num){
       shape_binding_prob_curve_kcell = num;
  }
  
  float TIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL(){
       return time_for_median_activation_prob_kcell;
  }
  void setTIME_FOR_MEDIAN_ACTIVATION_PROB_KCELL(float num){
       time_for_median_activation_prob_kcell = num;
  } 
  
  float SHAPE_ACTIVATION_PROB_CURVE_KCELL(){
       return shape_activation_prob_curve_kcell;
  }
  void setSHAPE_ACTIVATION_PROB_CURVE_KCELL(float num){
       shape_activation_prob_curve_kcell = num;
  }
  

  //float PROB_rHELPER_LICENSES_MDC(){
  //  return prob_rhelper_licenses_mdc;
  //}

  //void setPROB_rHELPER_LICENSES_MDC(float num){
  //  prob_rhelper_licenses_mdc = num;
  //}

  float PROB_aK_BECOMES_mK(){
    return prob_ak_becomes_mk;
  }

  void setPROB_aK_BECOMES_mK(float num){
    prob_ak_becomes_mk = num;
  }

  //float PROB_LDC_MATURES_DC(){
  //  return prob_ldc_matures_dc;
  //}

  //void setPROB_LDC_MATURES_DC(float num){
  //  prob_ldc_matures_dc = num;
  //}

  //float PROB_MDC_MATURES_IDC(){
  //  return prob_mdc_matures_idc;
  //}

  //void setPROB_MDC_MATURES_IDC(float num){
  //   prob_mdc_matures_idc = num;
  //  }

  //float PROB_PTC_MATURES_IDC(){
  //  return prob_ptc_matures_idc;
  //}

  //void setPROB_PTC_MATURES_IDC(float num){
  //  prob_ptc_matures_idc = num;
  //}

  float PROB_H_ENHANCED_RECRUITMENT(){
    return prob_h_enhanced_recruitment;
  }

  void setPROB_H_ENHANCED_RECRUITMENT(float num){
    prob_h_enhanced_recruitment = num;
  }

  float PROB_K_ENHANCED_RECRUITMENT(){
    return prob_k_enhanced_recruitment;
  }

  void setPROB_K_ENHANCED_RECRUITMENT(float num){
    prob_k_enhanced_recruitment = num;
  }

  float PROB_DC_ENHANCED_RECRUITMENT(){
    return prob_dc_enhanced_recruitment;
  }

  void setPROB_DC_ENHANCED_RECRUITMENT(float num){
    prob_dc_enhanced_recruitment = num;
  }
  
  //float PROB_BINDING_PRIMED_T4_WITH_IDC(){
  //  return prob_binding_primed_t4_with_idc;
  //}

  //void setPROB_BINDING_PRIMED_T4_WITH_IDC(float num){
  //  prob_binding_primed_t4_with_idc = num;
  //}

  float PROB_BINDING_T4_WITH_DC(){
    return prob_binding_t4_with_dc;
  }

  void setPROB_BINDING_T4_WITH_DC(float num){
    prob_binding_t4_with_dc = num;
  }

  float PROB_BINDING_T8_WITH_LDC(){
    return prob_binding_t8_with_ldc;
  }

  void setPROB_BINDING_T8_WITH_LDC(float num){
    prob_binding_t8_with_ldc = num;
  }

  float PROB_DC_ACTIVATES_T4(){
    return prob_dc_activates_t4;
  }

  void setPROB_DC_ACTIVATES_T4(float num){
    prob_dc_activates_t4 = num;
  }

  float PROB_LDC_ACTIVATES_T8(){
    return prob_ldc_activates_t8;
  }

  void setPROB_LDC_ACTIVATES_T8(float num){
    prob_ldc_activates_t8 = num;
  }

  /*int TOTAL_DEN_CELLS(){
    return total_den_cells;
  }

  void setTOTAL_DEN_CELLS(int num){
    total_den_cells = num;
    }*/

  /*void setPEAK_iDEN_CELLS(int num){
    peak_iden_cells = num;
  }

  int PEAK_iDEN_CELLS(){
    return peak_iden_cells;
    }*/

  void setPEAK_DEN_CELLS(int num){
    peak_den_cells = num;
  }

  int PEAK_DEN_CELLS(){
    return peak_den_cells;
  }

};

#endif /* LN_PAR_H */
